<?php
/**
 * Plugin Name: Moduł płatności Paybylink.pl - WP eCommerce
 * Plugin URL: https://paybylink.pl/
 * Author: Szymon Radoliński
 * Author URL: https://paybylink.pl/
 * Description: Moduł płatności przelewów operatora paybylink.pl do wtyczki WP eCommerce
 * Version 1.0
 */

$nzshpcrt_gateways[@$num]['name'] = 'Paybylink';
$nzshpcrt_gateways[@$num]['internalname'] = 'Paybylink';
$nzshpcrt_gateways[@$num]['function'] = 'pbl_gateway';
$nzshpcrt_gateways[@$num]['form'] = 'pbl_admin_form';
$nzshpcrt_gateways[@$num]['submit_function'] = 'pbl_form_submit';
$nzshpcrt_gateways[@$num]['display_name'] = 'Płatności Paybylink';

if(!get_option('pbl_shopid')) {
    update_option('pbl_shopid', ' ');
}

if(!get_option('pbl_hash')) {
    update_option('pbl_hash', ' ');
}

function pbl_admin_form() {
    $shopid = get_option('pbl_shopid');
    $hash = get_option('pbl_hash');

    $html = '<tr><td>Identyfikator sklepu</td><td><input type="text" name="pbl_shopid" id="pbl_shopid" value="' . $shopid . '" placeholder="Identyfikator sklepu"></td></tr>';
    $html .= '<tr><td>Hash</td><td><input type="text" name="pbl_hash" id="pbl_hash" value="' . $hash . '" placeholder="Hash"></td></tr>';

    return $html;
}

function pbl_form_submit() {
    $fields = array('pbl_shopid', 'pbl_hash');

    foreach($fields as $field) {
        if(isset($_POST[$field])) {
            update_option($field, $_POST[$field]);
        }
    }

    return true;
}

function pbl_gateway($seperator, $sessionid) {
    global $wpsc_cart;
    global $wpdb;

    $ordernumber = 'WPEC' . $wpdb->get_var("SELECT id FROM " . WPSC_TABLE_PURCHASE_LOGS . " WHERE sessionid = '$sessionid' LIMIT 1;");
    	
    if(strlen($ordernumber) > 20) {
        $ordernumber = time();
    }

    $purchase_log = $wpdb->get_row($wpdb->prepare("SELECT * FROM `" . WPSC_TABLE_PURCHASE_LOGS . "` WHERE `sessionid`= %s LIMIT 1",  $sessionid), ARRAY_A);
    
    $usersql = $wpdb->prepare("SELECT `" . WPSC_TABLE_SUBMITED_FORM_DATA . "`.value,
	`" . WPSC_TABLE_CHECKOUT_FORMS . "`.`name`,
	`" . WPSC_TABLE_CHECKOUT_FORMS . "`.`unique_name` FROM
	`" . WPSC_TABLE_CHECKOUT_FORMS . "` LEFT JOIN
	`" . WPSC_TABLE_SUBMITED_FORM_DATA . "` ON
	`" . WPSC_TABLE_CHECKOUT_FORMS . "`.id =
	`" . WPSC_TABLE_SUBMITED_FORM_DATA . "`.`form_id` WHERE
	`" . WPSC_TABLE_SUBMITED_FORM_DATA . "`.`log_id`=%s
	ORDER BY `" . WPSC_TABLE_CHECKOUT_FORMS . "`.`checkout_order`", $purchase_log['id']);

    $userinfo = $wpdb->get_results($usersql, ARRAY_A);
    
    $email = '';

    foreach ($userinfo as $key => $value) {   
        if (($value['unique_name'] == 'billingemail') && $value['value'] != '') {
            $email = $value['value'];
        }
    }

    $shopId             = intval(get_option('pbl_shopid'));
    $description        = strval('Zamówienie ' . $ordernumber);
    $control            = strval($ordernumber . '|' . $sessionid);
    $email              = strval($email);
    $price              = floatval($wpsc_cart->total_price);
    $notifyURL          = strval(get_pbl_itnurl());
    $returnUrlSuccess   = strval(get_pbl_accepturl($ordernumber, $session_id));
    $hash               = get_option('pbl_hash');

    $data   = $hash . "|" . $shopId . "|" . sprintf("%.2f", $price);

    if ($control != null && $control != "") {
        $data .= "|" . $control;
    }

    if ($description != null && $description != "") {
        $data .= "|" . $description;
    }
    
    if ($email != null && $email != "") {
        $data .= "|" . $email;
    }

    if ($notifyURL != null && $notifyURL != "") {
        $data .= "|" . $notifyURL;
    }

    if ($returnUrlSuccess != null && $returnUrlSuccess != "") {
        $data .= "|" . $returnUrlSuccess;
    }

    $signature = hash('sha256', $data);

    $paybylinkData  = [
        'shopId'            => $shopId,
        'price'             => $price,
        'control'           => $control,
        'description'       => $description,
        'email'             => $email,
        'notifyURL'         => $notifyURL,
        'returnUrlSuccess'  => $returnUrlSuccess,
        'signature'         => $signature
    ];

    $data_string = json_encode($paybylinkData);

    $ch = curl_init('https://secure.pbl.pl/api/v1/transfer/generate');                                                                      
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');                                                                    
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
        'Content-Type: application/json',                                                                                
        'Content-Length: ' . strlen($data_string))                                                                      
    );

    $result = curl_exec($ch);
    $result = json_decode($result);

    if(isset($result->transactionId) AND !empty($result->transactionId)) {
        $payURL = 'https://secure.pbl.pl/transfer/' . $result->transactionId;

        $wpdb->query("UPDATE " . WPSC_TABLE_PURCHASE_LOGS . " SET processed = '1', transactid = '" . $transaction_id . "', date = '" . time() . "' WHERE sessionid = " . $sessionid . " LIMIT 1");
    }

    header('Location: ' . $payURL);
    exit('<a href="' . $payURL . '">Kliknij tutaj jeśli nie zostaniesz przekierowany do płatności</a>');
}

function get_pbl_accepturl($transaction_id, $session_id) {
    $accepturl = get_option('transact_url');

    $params = array('pbl_accept' => '1', 'transaction_id' => $transaction_id, 'sessionid' => $session_id);
    return add_query_arg($params, $accepturl);
}

function get_pbl_itnurl() {
    return get_site_url() . '/wp-json/wp-ecommerce-paybylink/v1/ipn/';
}

function checkSignature($secret, $data){
    $sign = sprintf("%s|%s|%s|%s|%.2f|%d|%s|%d", $secret, $data['transactionId'], $data['control'], $data['email'], $data['amountPaid'], $data['notificationAttempt'], $data['paymentType'], $data['apiVersion']);
    $hash = hash('sha256', $sign);
    return $hash == $data['signature'];
}

function pbl_ipn() {
    header('HTTP/1.1 200 OK');
    header('Content-Type: text/plain');

    $response = file_get_contents('php://input');

    if(!empty($response)) {
        $response = json_decode($response, true);

        $pbl_data = array(
            'transactionId' => $response['transactionId'],
            'control' => $response['control'],
            'email' => $response['email'],
            'amountPaid' => $response['amountPaid'],
            'notificationAttempt' => $response['notificationAttempt'],
            'paymentType' => $response['paymentType'],
            'apiVersion' => $response['apiVersion'],
            'signature' => $response['signature']
        );

        if(!checkSignature(get_option('pbl_hash'), $pbl_data)) {
            exit('Wrong checksum');
        }

        list($ordernumber, $sessionid) = explode('|', $response['control']);

        $purchase_log = new WPSC_Purchase_Log($sessionid, 'sessionid');

        $purchase_log->set('processed', WPSC_Purchase_Log::ACCEPTED_PAYMENT);
        $purchase_log->set('transactid', $ordernumber);
        $purchase_log->set('notes', 'Płatność na kwotę ' . $response['amountPaid'] . ' PLN została opłacona w systemie Paybylink.pl');
        $purchase_log->save();

        ob_clean();
        exit('OK');
    } else {
        exit('Empty response');
    }       
}

add_action('rest_api_init', function() {
    register_rest_route('wp-ecommerce-paybylink/v1', '/ipn', array(
        'methods' => array('GET', 'POST'),
        'callback' => 'pbl_ipn'
    ));
});

function add_admin_menu(){
    add_menu_page( 'Płatności Paybylink', 'Płatności Paybylink', 'manage_options','options-general.php?page=wpsc-settings&tab=gateway&payment_gateway_id=Paybylink', '', plugins_url( 'favicon.png', __FILE__ ), 56 );
}

add_action('admin_menu', 'add_admin_menu');